#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 134
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 54
#define ALIAS_COUNT 17
#define TOKEN_COUNT 21
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 7
#define PRODUCTION_ID_COUNT 12

enum ts_symbol_identifiers {
  sym_identifier = 1,
  sym_body_block_keyword = 2,
  anon_sym_LBRACE = 3,
  anon_sym_RBRACE = 4,
  anon_sym_SEMI = 5,
  sym_promise_block_keyword = 6,
  sym_bundle_block_keyword = 7,
  anon_sym_LPAREN = 8,
  anon_sym_COMMA = 9,
  anon_sym_RPAREN = 10,
  anon_sym_DOLLAR = 11,
  anon_sym_AT = 12,
  anon_sym_DASH_GT = 13,
  anon_sym_EQ_GT = 14,
  sym_quoted_string = 15,
  sym_qualified_identifier = 16,
  sym_promise_guard = 17,
  sym_class_guard = 18,
  sym_comment = 19,
  sym_macro = 20,
  sym_source_file = 21,
  sym__block = 22,
  sym_body_block = 23,
  sym_body_block_body = 24,
  sym__body_attribute = 25,
  sym_promise_block = 26,
  sym_promise_block_body = 27,
  sym_class_guarded_body_attributes = 28,
  sym_bundle_block = 29,
  sym_parameter_list = 30,
  sym_bundle_block_body = 31,
  sym_bundle_section = 32,
  sym__right_value = 33,
  sym_dollar_expression = 34,
  sym_at_expression = 35,
  sym_call = 36,
  sym_list = 37,
  sym__value_list = 38,
  sym_class_guarded_promises = 39,
  sym__promises = 40,
  sym_promise = 41,
  sym_half_promise = 42,
  sym_attribute = 43,
  aux_sym_source_file_repeat1 = 44,
  aux_sym_body_block_body_repeat1 = 45,
  aux_sym_body_block_body_repeat2 = 46,
  aux_sym_promise_block_body_repeat1 = 47,
  aux_sym_parameter_list_repeat1 = 48,
  aux_sym_bundle_block_body_repeat1 = 49,
  aux_sym_bundle_section_repeat1 = 50,
  aux_sym__value_list_repeat1 = 51,
  aux_sym__promises_repeat1 = 52,
  aux_sym_promise_repeat1 = 53,
  alias_sym_at_expression_end = 54,
  alias_sym_at_expression_identifier = 55,
  alias_sym_at_expression_start = 56,
  alias_sym_attribute_name = 57,
  alias_sym_body_block_name = 58,
  alias_sym_body_block_type = 59,
  alias_sym_bundle_block_name = 60,
  alias_sym_bundle_block_type = 61,
  alias_sym_calling_identifier = 62,
  alias_sym_class_guarded_promise_block_attributes = 63,
  alias_sym_dollar_expression_end = 64,
  alias_sym_dollar_expression_identifier = 65,
  alias_sym_dollar_expression_start = 66,
  alias_sym_promise_block_name = 67,
  alias_sym_promise_block_type = 68,
  alias_sym_promiser = 69,
  alias_sym_stakeholder = 70,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "parameter",
  [sym_body_block_keyword] = "body_block_keyword",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_SEMI] = ";",
  [sym_promise_block_keyword] = "promise_block_keyword",
  [sym_bundle_block_keyword] = "bundle_block_keyword",
  [anon_sym_LPAREN] = "(",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [anon_sym_DOLLAR] = "dollar_expression_operator",
  [anon_sym_AT] = "at_expression_operator",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_EQ_GT] = "=>",
  [sym_quoted_string] = "quoted_string",
  [sym_qualified_identifier] = "qualified_identifier",
  [sym_promise_guard] = "promise_guard",
  [sym_class_guard] = "class_guard",
  [sym_comment] = "comment",
  [sym_macro] = "macro",
  [sym_source_file] = "source_file",
  [sym__block] = "_block",
  [sym_body_block] = "body_block",
  [sym_body_block_body] = "body_block_body",
  [sym__body_attribute] = "_body_attribute",
  [sym_promise_block] = "promise_block",
  [sym_promise_block_body] = "promise_block_body",
  [sym_class_guarded_body_attributes] = "class_guarded_body_attributes",
  [sym_bundle_block] = "bundle_block",
  [sym_parameter_list] = "parameter_list",
  [sym_bundle_block_body] = "bundle_block_body",
  [sym_bundle_section] = "bundle_section",
  [sym__right_value] = "_right_value",
  [sym_dollar_expression] = "dollar_expression",
  [sym_at_expression] = "at_expression",
  [sym_call] = "call",
  [sym_list] = "list",
  [sym__value_list] = "_value_list",
  [sym_class_guarded_promises] = "class_guarded_promises",
  [sym__promises] = "_promises",
  [sym_promise] = "promise",
  [sym_half_promise] = "half_promise",
  [sym_attribute] = "attribute",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_body_block_body_repeat1] = "body_block_body_repeat1",
  [aux_sym_body_block_body_repeat2] = "body_block_body_repeat2",
  [aux_sym_promise_block_body_repeat1] = "promise_block_body_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_bundle_block_body_repeat1] = "bundle_block_body_repeat1",
  [aux_sym_bundle_section_repeat1] = "bundle_section_repeat1",
  [aux_sym__value_list_repeat1] = "_value_list_repeat1",
  [aux_sym__promises_repeat1] = "_promises_repeat1",
  [aux_sym_promise_repeat1] = "promise_repeat1",
  [alias_sym_at_expression_end] = "at_expression_end",
  [alias_sym_at_expression_identifier] = "at_expression_identifier",
  [alias_sym_at_expression_start] = "at_expression_start",
  [alias_sym_attribute_name] = "attribute_name",
  [alias_sym_body_block_name] = "body_block_name",
  [alias_sym_body_block_type] = "body_block_type",
  [alias_sym_bundle_block_name] = "bundle_block_name",
  [alias_sym_bundle_block_type] = "bundle_block_type",
  [alias_sym_calling_identifier] = "calling_identifier",
  [alias_sym_class_guarded_promise_block_attributes] = "class_guarded_promise_block_attributes",
  [alias_sym_dollar_expression_end] = "dollar_expression_end",
  [alias_sym_dollar_expression_identifier] = "dollar_expression_identifier",
  [alias_sym_dollar_expression_start] = "dollar_expression_start",
  [alias_sym_promise_block_name] = "promise_block_name",
  [alias_sym_promise_block_type] = "promise_block_type",
  [alias_sym_promiser] = "promiser",
  [alias_sym_stakeholder] = "stakeholder",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_body_block_keyword] = sym_body_block_keyword,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [sym_promise_block_keyword] = sym_promise_block_keyword,
  [sym_bundle_block_keyword] = sym_bundle_block_keyword,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [sym_quoted_string] = sym_quoted_string,
  [sym_qualified_identifier] = sym_qualified_identifier,
  [sym_promise_guard] = sym_promise_guard,
  [sym_class_guard] = sym_class_guard,
  [sym_comment] = sym_comment,
  [sym_macro] = sym_macro,
  [sym_source_file] = sym_source_file,
  [sym__block] = sym__block,
  [sym_body_block] = sym_body_block,
  [sym_body_block_body] = sym_body_block_body,
  [sym__body_attribute] = sym__body_attribute,
  [sym_promise_block] = sym_promise_block,
  [sym_promise_block_body] = sym_promise_block_body,
  [sym_class_guarded_body_attributes] = sym_class_guarded_body_attributes,
  [sym_bundle_block] = sym_bundle_block,
  [sym_parameter_list] = sym_parameter_list,
  [sym_bundle_block_body] = sym_bundle_block_body,
  [sym_bundle_section] = sym_bundle_section,
  [sym__right_value] = sym__right_value,
  [sym_dollar_expression] = sym_dollar_expression,
  [sym_at_expression] = sym_at_expression,
  [sym_call] = sym_call,
  [sym_list] = sym_list,
  [sym__value_list] = sym__value_list,
  [sym_class_guarded_promises] = sym_class_guarded_promises,
  [sym__promises] = sym__promises,
  [sym_promise] = sym_promise,
  [sym_half_promise] = sym_half_promise,
  [sym_attribute] = sym_attribute,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_body_block_body_repeat1] = aux_sym_body_block_body_repeat1,
  [aux_sym_body_block_body_repeat2] = aux_sym_body_block_body_repeat2,
  [aux_sym_promise_block_body_repeat1] = aux_sym_promise_block_body_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym_bundle_block_body_repeat1] = aux_sym_bundle_block_body_repeat1,
  [aux_sym_bundle_section_repeat1] = aux_sym_bundle_section_repeat1,
  [aux_sym__value_list_repeat1] = aux_sym__value_list_repeat1,
  [aux_sym__promises_repeat1] = aux_sym__promises_repeat1,
  [aux_sym_promise_repeat1] = aux_sym_promise_repeat1,
  [alias_sym_at_expression_end] = alias_sym_at_expression_end,
  [alias_sym_at_expression_identifier] = alias_sym_at_expression_identifier,
  [alias_sym_at_expression_start] = alias_sym_at_expression_start,
  [alias_sym_attribute_name] = alias_sym_attribute_name,
  [alias_sym_body_block_name] = alias_sym_body_block_name,
  [alias_sym_body_block_type] = alias_sym_body_block_type,
  [alias_sym_bundle_block_name] = alias_sym_bundle_block_name,
  [alias_sym_bundle_block_type] = alias_sym_bundle_block_type,
  [alias_sym_calling_identifier] = alias_sym_calling_identifier,
  [alias_sym_class_guarded_promise_block_attributes] = alias_sym_class_guarded_promise_block_attributes,
  [alias_sym_dollar_expression_end] = alias_sym_dollar_expression_end,
  [alias_sym_dollar_expression_identifier] = alias_sym_dollar_expression_identifier,
  [alias_sym_dollar_expression_start] = alias_sym_dollar_expression_start,
  [alias_sym_promise_block_name] = alias_sym_promise_block_name,
  [alias_sym_promise_block_type] = alias_sym_promise_block_type,
  [alias_sym_promiser] = alias_sym_promiser,
  [alias_sym_stakeholder] = alias_sym_stakeholder,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_body_block_keyword] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [sym_promise_block_keyword] = {
    .visible = true,
    .named = true,
  },
  [sym_bundle_block_keyword] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_quoted_string] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_promise_guard] = {
    .visible = true,
    .named = true,
  },
  [sym_class_guard] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_macro] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__block] = {
    .visible = false,
    .named = true,
  },
  [sym_body_block] = {
    .visible = true,
    .named = true,
  },
  [sym_body_block_body] = {
    .visible = true,
    .named = true,
  },
  [sym__body_attribute] = {
    .visible = false,
    .named = true,
  },
  [sym_promise_block] = {
    .visible = true,
    .named = true,
  },
  [sym_promise_block_body] = {
    .visible = true,
    .named = true,
  },
  [sym_class_guarded_body_attributes] = {
    .visible = true,
    .named = true,
  },
  [sym_bundle_block] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_bundle_block_body] = {
    .visible = true,
    .named = true,
  },
  [sym_bundle_section] = {
    .visible = true,
    .named = true,
  },
  [sym__right_value] = {
    .visible = false,
    .named = true,
  },
  [sym_dollar_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_at_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym__value_list] = {
    .visible = false,
    .named = true,
  },
  [sym_class_guarded_promises] = {
    .visible = true,
    .named = true,
  },
  [sym__promises] = {
    .visible = false,
    .named = true,
  },
  [sym_promise] = {
    .visible = true,
    .named = true,
  },
  [sym_half_promise] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_body_block_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_body_block_body_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_promise_block_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_bundle_block_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_bundle_section_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__value_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__promises_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_promise_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_at_expression_end] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_at_expression_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_at_expression_start] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_attribute_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_body_block_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_body_block_type] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_bundle_block_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_bundle_block_type] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_calling_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_class_guarded_promise_block_attributes] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_dollar_expression_end] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_dollar_expression_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_dollar_expression_start] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_promise_block_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_promise_block_type] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_promiser] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_stakeholder] = {
    .visible = true,
    .named = true,
  },
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [1] = alias_sym_body_block_type,
    [2] = alias_sym_body_block_name,
  },
  [2] = {
    [1] = alias_sym_promise_block_type,
    [2] = alias_sym_promise_block_name,
  },
  [3] = {
    [1] = alias_sym_bundle_block_type,
    [2] = alias_sym_bundle_block_name,
  },
  [4] = {
    [0] = alias_sym_class_guarded_promise_block_attributes,
  },
  [5] = {
    [0] = alias_sym_attribute_name,
  },
  [6] = {
    [0] = alias_sym_promiser,
  },
  [7] = {
    [0] = alias_sym_calling_identifier,
  },
  [8] = {
    [0] = alias_sym_promiser,
    [2] = alias_sym_stakeholder,
  },
  [9] = {
    [1] = alias_sym_dollar_expression_start,
    [2] = alias_sym_dollar_expression_identifier,
    [3] = alias_sym_dollar_expression_end,
  },
  [10] = {
    [1] = alias_sym_dollar_expression_start,
    [3] = alias_sym_dollar_expression_end,
  },
  [11] = {
    [1] = alias_sym_at_expression_start,
    [2] = alias_sym_at_expression_identifier,
    [3] = alias_sym_at_expression_end,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_class_guarded_body_attributes, 2,
    sym_class_guarded_body_attributes,
    alias_sym_class_guarded_promise_block_attributes,
  sym__right_value, 2,
    sym__right_value,
    alias_sym_stakeholder,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
};

static TSCharacterRange sym_class_guard_character_set_2[] = {
  {'\t', '\t'}, {' ', '!'}, {'&', '&'}, {'(', ')'}, {'.', '.'}, {'0', ':'}, {'A', 'Z'}, {'_', '_'},
  {'a', 'z'}, {'|', '|'},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(23);
      ADVANCE_MAP(
        '"', 4,
        '#', 45,
        '$', 30,
        '\'', 5,
        '(', 27,
        ')', 29,
        ',', 28,
        '-', 8,
        ';', 26,
        '=', 9,
        '@', 31,
        '`', 10,
        '{', 24,
        '}', 25,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(35);
      END_STATE();
    case 1:
      if (lookahead == ' ') ADVANCE(46);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        '"', 4,
        '#', 45,
        '$', 30,
        '\'', 5,
        ')', 29,
        '@', 31,
        '`', 10,
        '{', 24,
        '}', 25,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(39);
      END_STATE();
    case 3:
      if (lookahead == '"') ADVANCE(4);
      if (lookahead == '#') ADVANCE(45);
      if (lookahead == '\'') ADVANCE(5);
      if (lookahead == '@') ADVANCE(12);
      if (lookahead == '`') ADVANCE(10);
      if (lookahead == '}') ADVANCE(25);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3);
      if (lookahead == '!' ||
          ('&' <= lookahead && lookahead <= ')') ||
          lookahead == '.' ||
          lookahead == ':' ||
          lookahead == '|') ADVANCE(7);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(37);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(36);
      END_STATE();
    case 4:
      if (lookahead == '"') ADVANCE(34);
      if (lookahead == '\\') ADVANCE(21);
      if (lookahead != 0) ADVANCE(4);
      END_STATE();
    case 5:
      if (lookahead == '\'') ADVANCE(34);
      if (lookahead == '\\') ADVANCE(22);
      if (lookahead != 0) ADVANCE(5);
      END_STATE();
    case 6:
      if (lookahead == ':') ADVANCE(44);
      if (set_contains(sym_class_guard_character_set_2, 10, lookahead)) ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == ':') ADVANCE(6);
      if (set_contains(sym_class_guard_character_set_2, 10, lookahead)) ADVANCE(7);
      END_STATE();
    case 8:
      if (lookahead == '>') ADVANCE(32);
      END_STATE();
    case 9:
      if (lookahead == '>') ADVANCE(33);
      END_STATE();
    case 10:
      if (lookahead == '`') ADVANCE(34);
      if (lookahead != 0) ADVANCE(10);
      END_STATE();
    case 11:
      if (lookahead == 'd') ADVANCE(16);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(17);
      if (lookahead == 'i') ADVANCE(14);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(46);
      END_STATE();
    case 14:
      if (lookahead == 'f') ADVANCE(1);
      END_STATE();
    case 15:
      if (lookahead == 'f') ADVANCE(46);
      END_STATE();
    case 16:
      if (lookahead == 'i') ADVANCE(15);
      END_STATE();
    case 17:
      if (lookahead == 'l') ADVANCE(18);
      if (lookahead == 'n') ADVANCE(11);
      END_STATE();
    case 18:
      if (lookahead == 's') ADVANCE(13);
      END_STATE();
    case 19:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(41);
      END_STATE();
    case 20:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(40);
      END_STATE();
    case 21:
      if (lookahead != 0) ADVANCE(4);
      END_STATE();
    case 22:
      if (lookahead != 0) ADVANCE(5);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == 'e') ADVANCE(17);
      if (lookahead == 'i') ADVANCE(14);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(sym_quoted_string);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == ':') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(38);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(35);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == ':') ADVANCE(43);
      if (lookahead == '\t' ||
          lookahead == ' ' ||
          lookahead == '!' ||
          lookahead == '&' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == '.' ||
          lookahead == '|') ADVANCE(7);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(37);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(36);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == ':') ADVANCE(6);
      if (lookahead == '\t' ||
          lookahead == ' ' ||
          lookahead == '!' ||
          lookahead == '&' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == '.' ||
          lookahead == '|') ADVANCE(7);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(37);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(38);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(sym_qualified_identifier);
      if (lookahead == '.') ADVANCE(19);
      if (lookahead == ':') ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(39);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(sym_qualified_identifier);
      if (lookahead == '.') ADVANCE(19);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(40);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(sym_qualified_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(41);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(sym_promise_guard);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(sym_promise_guard);
      if (lookahead == ':') ADVANCE(44);
      if (set_contains(sym_class_guard_character_set_2, 10, lookahead)) ADVANCE(7);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_class_guard);
      if (lookahead == ':') ADVANCE(44);
      if (set_contains(sym_class_guard_character_set_2, 10, lookahead)) ADVANCE(7);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(45);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(sym_macro);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(46);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'b') ADVANCE(1);
      if (lookahead == 'p') ADVANCE(2);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'o') ADVANCE(3);
      if (lookahead == 'u') ADVANCE(4);
      END_STATE();
    case 2:
      if (lookahead == 'r') ADVANCE(5);
      END_STATE();
    case 3:
      if (lookahead == 'd') ADVANCE(6);
      END_STATE();
    case 4:
      if (lookahead == 'n') ADVANCE(7);
      END_STATE();
    case 5:
      if (lookahead == 'o') ADVANCE(8);
      END_STATE();
    case 6:
      if (lookahead == 'y') ADVANCE(9);
      END_STATE();
    case 7:
      if (lookahead == 'd') ADVANCE(10);
      END_STATE();
    case 8:
      if (lookahead == 'm') ADVANCE(11);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(sym_body_block_keyword);
      END_STATE();
    case 10:
      if (lookahead == 'l') ADVANCE(12);
      END_STATE();
    case 11:
      if (lookahead == 'i') ADVANCE(13);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(14);
      END_STATE();
    case 13:
      if (lookahead == 's') ADVANCE(15);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(sym_bundle_block_keyword);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(16);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(sym_promise_block_keyword);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 0},
  [2] = {.lex_state = 2},
  [3] = {.lex_state = 2},
  [4] = {.lex_state = 2},
  [5] = {.lex_state = 2},
  [6] = {.lex_state = 2},
  [7] = {.lex_state = 2},
  [8] = {.lex_state = 2},
  [9] = {.lex_state = 3},
  [10] = {.lex_state = 3},
  [11] = {.lex_state = 0},
  [12] = {.lex_state = 3},
  [13] = {.lex_state = 0},
  [14] = {.lex_state = 3},
  [15] = {.lex_state = 3},
  [16] = {.lex_state = 3},
  [17] = {.lex_state = 3},
  [18] = {.lex_state = 3},
  [19] = {.lex_state = 3},
  [20] = {.lex_state = 3},
  [21] = {.lex_state = 0},
  [22] = {.lex_state = 3},
  [23] = {.lex_state = 0},
  [24] = {.lex_state = 3},
  [25] = {.lex_state = 3},
  [26] = {.lex_state = 3},
  [27] = {.lex_state = 3},
  [28] = {.lex_state = 3},
  [29] = {.lex_state = 3},
  [30] = {.lex_state = 0},
  [31] = {.lex_state = 3},
  [32] = {.lex_state = 0},
  [33] = {.lex_state = 3},
  [34] = {.lex_state = 0},
  [35] = {.lex_state = 0},
  [36] = {.lex_state = 3},
  [37] = {.lex_state = 3},
  [38] = {.lex_state = 3},
  [39] = {.lex_state = 3},
  [40] = {.lex_state = 0},
  [41] = {.lex_state = 0},
  [42] = {.lex_state = 0},
  [43] = {.lex_state = 0},
  [44] = {.lex_state = 3},
  [45] = {.lex_state = 0},
  [46] = {.lex_state = 3},
  [47] = {.lex_state = 3},
  [48] = {.lex_state = 3},
  [49] = {.lex_state = 0},
  [50] = {.lex_state = 0},
  [51] = {.lex_state = 0},
  [52] = {.lex_state = 0},
  [53] = {.lex_state = 0},
  [54] = {.lex_state = 0},
  [55] = {.lex_state = 0},
  [56] = {.lex_state = 0},
  [57] = {.lex_state = 0},
  [58] = {.lex_state = 0},
  [59] = {.lex_state = 0},
  [60] = {.lex_state = 0},
  [61] = {.lex_state = 0},
  [62] = {.lex_state = 0},
  [63] = {.lex_state = 3},
  [64] = {.lex_state = 0},
  [65] = {.lex_state = 3},
  [66] = {.lex_state = 0},
  [67] = {.lex_state = 0},
  [68] = {.lex_state = 3},
  [69] = {.lex_state = 0},
  [70] = {.lex_state = 0},
  [71] = {.lex_state = 0},
  [72] = {.lex_state = 3},
  [73] = {.lex_state = 3},
  [74] = {.lex_state = 3},
  [75] = {.lex_state = 0},
  [76] = {.lex_state = 0},
  [77] = {.lex_state = 0},
  [78] = {.lex_state = 2},
  [79] = {.lex_state = 0},
  [80] = {.lex_state = 0},
  [81] = {.lex_state = 0},
  [82] = {.lex_state = 0},
  [83] = {.lex_state = 0},
  [84] = {.lex_state = 0},
  [85] = {.lex_state = 0},
  [86] = {.lex_state = 0},
  [87] = {.lex_state = 0},
  [88] = {.lex_state = 0},
  [89] = {.lex_state = 0},
  [90] = {.lex_state = 3},
  [91] = {.lex_state = 0},
  [92] = {.lex_state = 0},
  [93] = {.lex_state = 0},
  [94] = {.lex_state = 0},
  [95] = {.lex_state = 0},
  [96] = {.lex_state = 0},
  [97] = {.lex_state = 3},
  [98] = {.lex_state = 0},
  [99] = {.lex_state = 0},
  [100] = {.lex_state = 0},
  [101] = {.lex_state = 0},
  [102] = {.lex_state = 0},
  [103] = {.lex_state = 0},
  [104] = {.lex_state = 0},
  [105] = {.lex_state = 3},
  [106] = {.lex_state = 0},
  [107] = {.lex_state = 0},
  [108] = {.lex_state = 0},
  [109] = {.lex_state = 0},
  [110] = {.lex_state = 0},
  [111] = {.lex_state = 0},
  [112] = {.lex_state = 0},
  [113] = {.lex_state = 0},
  [114] = {.lex_state = 0},
  [115] = {.lex_state = 0},
  [116] = {.lex_state = 0},
  [117] = {.lex_state = 0},
  [118] = {.lex_state = 0},
  [119] = {.lex_state = 0},
  [120] = {.lex_state = 0},
  [121] = {.lex_state = 0},
  [122] = {.lex_state = 0},
  [123] = {.lex_state = 0},
  [124] = {.lex_state = 0},
  [125] = {.lex_state = 0},
  [126] = {.lex_state = 0},
  [127] = {.lex_state = 2},
  [128] = {.lex_state = 0},
  [129] = {.lex_state = 0},
  [130] = {.lex_state = 0},
  [131] = {.lex_state = 0},
  [132] = {.lex_state = 0},
  [133] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_body_block_keyword] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [sym_promise_block_keyword] = ACTIONS(1),
    [sym_bundle_block_keyword] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [sym_quoted_string] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_macro] = ACTIONS(3),
  },
  [1] = {
    [sym_source_file] = STATE(121),
    [sym__block] = STATE(13),
    [sym_body_block] = STATE(13),
    [sym_promise_block] = STATE(13),
    [sym_bundle_block] = STATE(13),
    [aux_sym_source_file_repeat1] = STATE(13),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_body_block_keyword] = ACTIONS(7),
    [sym_promise_block_keyword] = ACTIONS(9),
    [sym_bundle_block_keyword] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [sym_macro] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 9,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(17), 1,
      anon_sym_DOLLAR,
    ACTIONS(19), 1,
      anon_sym_AT,
    ACTIONS(21), 1,
      sym_quoted_string,
    ACTIONS(23), 1,
      sym_qualified_identifier,
    STATE(89), 1,
      sym__right_value,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(15), 2,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
    STATE(45), 4,
      sym_dollar_expression,
      sym_at_expression,
      sym_call,
      sym_list,
  [33] = 10,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(17), 1,
      anon_sym_DOLLAR,
    ACTIONS(19), 1,
      anon_sym_AT,
    ACTIONS(21), 1,
      sym_quoted_string,
    ACTIONS(23), 1,
      sym_qualified_identifier,
    ACTIONS(25), 1,
      anon_sym_RPAREN,
    STATE(75), 1,
      sym__right_value,
    STATE(130), 1,
      sym__value_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    STATE(45), 4,
      sym_dollar_expression,
      sym_at_expression,
      sym_call,
      sym_list,
  [68] = 9,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(17), 1,
      anon_sym_DOLLAR,
    ACTIONS(19), 1,
      anon_sym_AT,
    ACTIONS(21), 1,
      sym_quoted_string,
    ACTIONS(23), 1,
      sym_qualified_identifier,
    STATE(89), 1,
      sym__right_value,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(27), 2,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
    STATE(45), 4,
      sym_dollar_expression,
      sym_at_expression,
      sym_call,
      sym_list,
  [101] = 10,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(17), 1,
      anon_sym_DOLLAR,
    ACTIONS(19), 1,
      anon_sym_AT,
    ACTIONS(21), 1,
      sym_quoted_string,
    ACTIONS(23), 1,
      sym_qualified_identifier,
    ACTIONS(29), 1,
      anon_sym_RBRACE,
    STATE(75), 1,
      sym__right_value,
    STATE(113), 1,
      sym__value_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    STATE(45), 4,
      sym_dollar_expression,
      sym_at_expression,
      sym_call,
      sym_list,
  [136] = 8,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(17), 1,
      anon_sym_DOLLAR,
    ACTIONS(19), 1,
      anon_sym_AT,
    ACTIONS(21), 1,
      sym_quoted_string,
    ACTIONS(23), 1,
      sym_qualified_identifier,
    STATE(102), 1,
      sym__right_value,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    STATE(45), 4,
      sym_dollar_expression,
      sym_at_expression,
      sym_call,
      sym_list,
  [165] = 8,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(17), 1,
      anon_sym_DOLLAR,
    ACTIONS(19), 1,
      anon_sym_AT,
    ACTIONS(21), 1,
      sym_quoted_string,
    ACTIONS(23), 1,
      sym_qualified_identifier,
    STATE(32), 1,
      sym__right_value,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    STATE(45), 4,
      sym_dollar_expression,
      sym_at_expression,
      sym_call,
      sym_list,
  [194] = 8,
    ACTIONS(13), 1,
      anon_sym_LBRACE,
    ACTIONS(17), 1,
      anon_sym_DOLLAR,
    ACTIONS(19), 1,
      anon_sym_AT,
    ACTIONS(21), 1,
      sym_quoted_string,
    ACTIONS(23), 1,
      sym_qualified_identifier,
    STATE(89), 1,
      sym__right_value,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    STATE(45), 4,
      sym_dollar_expression,
      sym_at_expression,
      sym_call,
      sym_list,
  [223] = 7,
    ACTIONS(31), 1,
      sym_identifier,
    ACTIONS(35), 1,
      sym_quoted_string,
    ACTIONS(37), 1,
      sym_promise_guard,
    STATE(77), 1,
      sym_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(33), 2,
      anon_sym_RBRACE,
      sym_class_guard,
    STATE(10), 3,
      sym_promise,
      sym_half_promise,
      aux_sym__promises_repeat1,
  [249] = 7,
    ACTIONS(39), 1,
      sym_identifier,
    ACTIONS(44), 1,
      sym_quoted_string,
    ACTIONS(47), 1,
      sym_promise_guard,
    STATE(77), 1,
      sym_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(42), 2,
      anon_sym_RBRACE,
      sym_class_guard,
    STATE(10), 3,
      sym_promise,
      sym_half_promise,
      aux_sym__promises_repeat1,
  [275] = 6,
    ACTIONS(49), 1,
      ts_builtin_sym_end,
    ACTIONS(51), 1,
      sym_body_block_keyword,
    ACTIONS(54), 1,
      sym_promise_block_keyword,
    ACTIONS(57), 1,
      sym_bundle_block_keyword,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    STATE(11), 5,
      sym__block,
      sym_body_block,
      sym_promise_block,
      sym_bundle_block,
      aux_sym_source_file_repeat1,
  [299] = 7,
    ACTIONS(31), 1,
      sym_identifier,
    ACTIONS(35), 1,
      sym_quoted_string,
    ACTIONS(62), 1,
      sym_promise_guard,
    STATE(77), 1,
      sym_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(60), 2,
      anon_sym_RBRACE,
      sym_class_guard,
    STATE(9), 3,
      sym_promise,
      sym_half_promise,
      aux_sym__promises_repeat1,
  [325] = 6,
    ACTIONS(7), 1,
      sym_body_block_keyword,
    ACTIONS(9), 1,
      sym_promise_block_keyword,
    ACTIONS(11), 1,
      sym_bundle_block_keyword,
    ACTIONS(64), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    STATE(11), 5,
      sym__block,
      sym_body_block,
      sym_promise_block,
      sym_bundle_block,
      aux_sym_source_file_repeat1,
  [349] = 8,
    ACTIONS(31), 1,
      sym_identifier,
    ACTIONS(66), 1,
      anon_sym_RBRACE,
    ACTIONS(68), 1,
      sym_class_guard,
    STATE(63), 1,
      aux_sym_promise_block_body_repeat1,
    STATE(105), 1,
      sym_class_guarded_body_attributes,
    STATE(128), 1,
      sym_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    STATE(15), 2,
      sym__body_attribute,
      aux_sym_body_block_body_repeat1,
  [376] = 8,
    ACTIONS(31), 1,
      sym_identifier,
    ACTIONS(68), 1,
      sym_class_guard,
    ACTIONS(70), 1,
      anon_sym_RBRACE,
    STATE(72), 1,
      aux_sym_promise_block_body_repeat1,
    STATE(105), 1,
      sym_class_guarded_body_attributes,
    STATE(128), 1,
      sym_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    STATE(19), 2,
      sym__body_attribute,
      aux_sym_body_block_body_repeat1,
  [403] = 8,
    ACTIONS(35), 1,
      sym_quoted_string,
    ACTIONS(72), 1,
      anon_sym_RBRACE,
    ACTIONS(74), 1,
      sym_promise_guard,
    ACTIONS(76), 1,
      sym_class_guard,
    STATE(12), 1,
      sym_promise,
    STATE(26), 1,
      sym__promises,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    STATE(39), 2,
      sym_class_guarded_promises,
      aux_sym_bundle_section_repeat1,
  [430] = 7,
    ACTIONS(31), 1,
      sym_identifier,
    ACTIONS(68), 1,
      sym_class_guard,
    ACTIONS(78), 1,
      anon_sym_RBRACE,
    STATE(128), 1,
      sym_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    STATE(18), 2,
      sym__body_attribute,
      aux_sym_body_block_body_repeat1,
    STATE(73), 2,
      sym_class_guarded_body_attributes,
      aux_sym_body_block_body_repeat2,
  [455] = 7,
    ACTIONS(31), 1,
      sym_identifier,
    ACTIONS(68), 1,
      sym_class_guard,
    ACTIONS(80), 1,
      anon_sym_RBRACE,
    STATE(128), 1,
      sym_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    STATE(19), 2,
      sym__body_attribute,
      aux_sym_body_block_body_repeat1,
    STATE(65), 2,
      sym_class_guarded_body_attributes,
      aux_sym_body_block_body_repeat2,
  [480] = 5,
    ACTIONS(82), 1,
      sym_identifier,
    STATE(128), 1,
      sym_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(85), 2,
      anon_sym_RBRACE,
      sym_class_guard,
    STATE(19), 2,
      sym__body_attribute,
      aux_sym_body_block_body_repeat1,
  [499] = 5,
    ACTIONS(31), 1,
      sym_identifier,
    STATE(128), 1,
      sym_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(87), 2,
      anon_sym_RBRACE,
      sym_class_guard,
    STATE(19), 2,
      sym__body_attribute,
      aux_sym_body_block_body_repeat1,
  [518] = 7,
    ACTIONS(89), 1,
      sym_identifier,
    ACTIONS(91), 1,
      anon_sym_SEMI,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(95), 1,
      anon_sym_DASH_GT,
    STATE(91), 1,
      aux_sym_promise_repeat1,
    STATE(96), 1,
      sym_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [541] = 6,
    ACTIONS(35), 1,
      sym_quoted_string,
    ACTIONS(99), 1,
      sym_promise_guard,
    STATE(12), 1,
      sym_promise,
    STATE(97), 1,
      sym__promises,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(97), 2,
      anon_sym_RBRACE,
      sym_class_guard,
  [562] = 3,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(101), 5,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      sym_identifier,
  [577] = 5,
    ACTIONS(31), 1,
      sym_identifier,
    STATE(128), 1,
      sym_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(105), 2,
      anon_sym_RBRACE,
      sym_class_guard,
    STATE(20), 2,
      sym__body_attribute,
      aux_sym_body_block_body_repeat1,
  [596] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(107), 2,
      sym_identifier,
      sym_promise_guard,
    ACTIONS(109), 3,
      anon_sym_RBRACE,
      sym_quoted_string,
      sym_class_guard,
  [610] = 5,
    ACTIONS(76), 1,
      sym_class_guard,
    ACTIONS(111), 1,
      anon_sym_RBRACE,
    ACTIONS(113), 1,
      sym_promise_guard,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    STATE(28), 2,
      sym_class_guarded_promises,
      aux_sym_bundle_section_repeat1,
  [628] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(115), 2,
      sym_identifier,
      sym_promise_guard,
    ACTIONS(117), 3,
      anon_sym_RBRACE,
      sym_quoted_string,
      sym_class_guard,
  [642] = 5,
    ACTIONS(76), 1,
      sym_class_guard,
    ACTIONS(119), 1,
      anon_sym_RBRACE,
    ACTIONS(121), 1,
      sym_promise_guard,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    STATE(29), 2,
      sym_class_guarded_promises,
      aux_sym_bundle_section_repeat1,
  [660] = 5,
    ACTIONS(123), 1,
      anon_sym_RBRACE,
    ACTIONS(125), 1,
      sym_promise_guard,
    ACTIONS(127), 1,
      sym_class_guard,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    STATE(29), 2,
      sym_class_guarded_promises,
      aux_sym_bundle_section_repeat1,
  [678] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(130), 5,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      sym_identifier,
  [690] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(132), 2,
      sym_identifier,
      sym_promise_guard,
    ACTIONS(134), 3,
      anon_sym_RBRACE,
      sym_quoted_string,
      sym_class_guard,
  [704] = 6,
    ACTIONS(89), 1,
      sym_identifier,
    ACTIONS(136), 1,
      anon_sym_SEMI,
    ACTIONS(138), 1,
      anon_sym_COMMA,
    STATE(85), 1,
      sym_attribute,
    STATE(86), 1,
      aux_sym_promise_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [724] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(140), 2,
      sym_identifier,
      sym_promise_guard,
    ACTIONS(142), 3,
      anon_sym_RBRACE,
      sym_quoted_string,
      sym_class_guard,
  [738] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(144), 5,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      sym_identifier,
  [750] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(146), 5,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      sym_identifier,
  [762] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(148), 2,
      sym_identifier,
      sym_promise_guard,
    ACTIONS(150), 3,
      anon_sym_RBRACE,
      sym_quoted_string,
      sym_class_guard,
  [776] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(152), 2,
      sym_identifier,
      sym_promise_guard,
    ACTIONS(154), 3,
      anon_sym_RBRACE,
      sym_quoted_string,
      sym_class_guard,
  [790] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(156), 2,
      sym_identifier,
      sym_promise_guard,
    ACTIONS(158), 3,
      anon_sym_RBRACE,
      sym_quoted_string,
      sym_class_guard,
  [804] = 5,
    ACTIONS(76), 1,
      sym_class_guard,
    ACTIONS(111), 1,
      anon_sym_RBRACE,
    ACTIONS(113), 1,
      sym_promise_guard,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    STATE(29), 2,
      sym_class_guarded_promises,
      aux_sym_bundle_section_repeat1,
  [822] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(160), 5,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      sym_identifier,
  [834] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(162), 5,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      sym_identifier,
  [846] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(164), 5,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      sym_identifier,
  [858] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(166), 5,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      sym_identifier,
  [870] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(168), 2,
      sym_identifier,
      sym_promise_guard,
    ACTIONS(170), 3,
      anon_sym_RBRACE,
      sym_quoted_string,
      sym_class_guard,
  [884] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(101), 5,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      sym_identifier,
  [896] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(172), 2,
      sym_identifier,
      sym_promise_guard,
    ACTIONS(174), 3,
      anon_sym_RBRACE,
      sym_quoted_string,
      sym_class_guard,
  [910] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(176), 2,
      sym_identifier,
      sym_promise_guard,
    ACTIONS(178), 3,
      anon_sym_RBRACE,
      sym_quoted_string,
      sym_class_guard,
  [924] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(180), 2,
      sym_identifier,
      sym_promise_guard,
    ACTIONS(182), 3,
      anon_sym_RBRACE,
      sym_quoted_string,
      sym_class_guard,
  [938] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(184), 4,
      ts_builtin_sym_end,
      sym_body_block_keyword,
      sym_promise_block_keyword,
      sym_bundle_block_keyword,
  [949] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(186), 4,
      ts_builtin_sym_end,
      sym_body_block_keyword,
      sym_promise_block_keyword,
      sym_bundle_block_keyword,
  [960] = 4,
    ACTIONS(188), 1,
      anon_sym_RBRACE,
    ACTIONS(190), 1,
      sym_promise_guard,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    STATE(52), 2,
      sym_bundle_section,
      aux_sym_bundle_block_body_repeat1,
  [975] = 4,
    ACTIONS(190), 1,
      sym_promise_guard,
    ACTIONS(192), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    STATE(61), 2,
      sym_bundle_section,
      aux_sym_bundle_block_body_repeat1,
  [990] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(194), 4,
      ts_builtin_sym_end,
      sym_body_block_keyword,
      sym_promise_block_keyword,
      sym_bundle_block_keyword,
  [1001] = 5,
    ACTIONS(196), 1,
      anon_sym_LBRACE,
    ACTIONS(198), 1,
      anon_sym_LPAREN,
    STATE(55), 1,
      sym_bundle_block_body,
    STATE(106), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1018] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(200), 4,
      ts_builtin_sym_end,
      sym_body_block_keyword,
      sym_promise_block_keyword,
      sym_bundle_block_keyword,
  [1029] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(202), 4,
      ts_builtin_sym_end,
      sym_body_block_keyword,
      sym_promise_block_keyword,
      sym_bundle_block_keyword,
  [1040] = 4,
    ACTIONS(204), 1,
      anon_sym_COMMA,
    STATE(64), 1,
      aux_sym__value_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(15), 2,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
  [1055] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(206), 4,
      ts_builtin_sym_end,
      sym_body_block_keyword,
      sym_promise_block_keyword,
      sym_bundle_block_keyword,
  [1066] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(208), 4,
      ts_builtin_sym_end,
      sym_body_block_keyword,
      sym_promise_block_keyword,
      sym_bundle_block_keyword,
  [1077] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(210), 4,
      ts_builtin_sym_end,
      sym_body_block_keyword,
      sym_promise_block_keyword,
      sym_bundle_block_keyword,
  [1088] = 4,
    ACTIONS(212), 1,
      anon_sym_RBRACE,
    ACTIONS(214), 1,
      sym_promise_guard,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    STATE(61), 2,
      sym_bundle_section,
      aux_sym_bundle_block_body_repeat1,
  [1103] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(217), 4,
      ts_builtin_sym_end,
      sym_body_block_keyword,
      sym_promise_block_keyword,
      sym_bundle_block_keyword,
  [1114] = 5,
    ACTIONS(68), 1,
      sym_class_guard,
    ACTIONS(70), 1,
      anon_sym_RBRACE,
    STATE(74), 1,
      aux_sym_promise_block_body_repeat1,
    STATE(105), 1,
      sym_class_guarded_body_attributes,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1131] = 4,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    STATE(64), 1,
      aux_sym__value_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(219), 2,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
  [1146] = 4,
    ACTIONS(68), 1,
      sym_class_guard,
    ACTIONS(224), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    STATE(68), 2,
      sym_class_guarded_body_attributes,
      aux_sym_body_block_body_repeat2,
  [1161] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(226), 4,
      ts_builtin_sym_end,
      sym_body_block_keyword,
      sym_promise_block_keyword,
      sym_bundle_block_keyword,
  [1172] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(228), 4,
      ts_builtin_sym_end,
      sym_body_block_keyword,
      sym_promise_block_keyword,
      sym_bundle_block_keyword,
  [1183] = 4,
    ACTIONS(230), 1,
      anon_sym_RBRACE,
    ACTIONS(232), 1,
      sym_class_guard,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    STATE(68), 2,
      sym_class_guarded_body_attributes,
      aux_sym_body_block_body_repeat2,
  [1198] = 5,
    ACTIONS(198), 1,
      anon_sym_LPAREN,
    ACTIONS(235), 1,
      anon_sym_LBRACE,
    STATE(62), 1,
      sym_body_block_body,
    STATE(100), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1215] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(237), 4,
      ts_builtin_sym_end,
      sym_body_block_keyword,
      sym_promise_block_keyword,
      sym_bundle_block_keyword,
  [1226] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(239), 4,
      ts_builtin_sym_end,
      sym_body_block_keyword,
      sym_promise_block_keyword,
      sym_bundle_block_keyword,
  [1237] = 5,
    ACTIONS(68), 1,
      sym_class_guard,
    ACTIONS(241), 1,
      anon_sym_RBRACE,
    STATE(74), 1,
      aux_sym_promise_block_body_repeat1,
    STATE(105), 1,
      sym_class_guarded_body_attributes,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1254] = 4,
    ACTIONS(68), 1,
      sym_class_guard,
    ACTIONS(80), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    STATE(68), 2,
      sym_class_guarded_body_attributes,
      aux_sym_body_block_body_repeat2,
  [1269] = 5,
    ACTIONS(243), 1,
      anon_sym_RBRACE,
    ACTIONS(245), 1,
      sym_class_guard,
    STATE(74), 1,
      aux_sym_promise_block_body_repeat1,
    STATE(105), 1,
      sym_class_guarded_body_attributes,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1286] = 4,
    ACTIONS(250), 1,
      anon_sym_COMMA,
    STATE(57), 1,
      aux_sym__value_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(248), 2,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
  [1301] = 4,
    ACTIONS(89), 1,
      sym_identifier,
    ACTIONS(252), 1,
      anon_sym_SEMI,
    STATE(107), 1,
      sym_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1315] = 4,
    ACTIONS(254), 1,
      anon_sym_SEMI,
    ACTIONS(256), 1,
      anon_sym_COMMA,
    STATE(83), 1,
      aux_sym_promise_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1329] = 4,
    ACTIONS(17), 1,
      anon_sym_DOLLAR,
    ACTIONS(258), 1,
      sym_qualified_identifier,
    STATE(125), 1,
      sym_dollar_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1343] = 4,
    ACTIONS(89), 1,
      sym_identifier,
    ACTIONS(260), 1,
      anon_sym_SEMI,
    STATE(107), 1,
      sym_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1357] = 4,
    ACTIONS(260), 1,
      anon_sym_SEMI,
    ACTIONS(262), 1,
      anon_sym_COMMA,
    STATE(81), 1,
      aux_sym_promise_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1371] = 4,
    ACTIONS(264), 1,
      anon_sym_SEMI,
    ACTIONS(266), 1,
      anon_sym_COMMA,
    STATE(81), 1,
      aux_sym_promise_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1385] = 4,
    ACTIONS(89), 1,
      sym_identifier,
    ACTIONS(269), 1,
      anon_sym_SEMI,
    STATE(107), 1,
      sym_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1399] = 4,
    ACTIONS(269), 1,
      anon_sym_SEMI,
    ACTIONS(271), 1,
      anon_sym_COMMA,
    STATE(81), 1,
      aux_sym_promise_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1413] = 4,
    ACTIONS(89), 1,
      sym_identifier,
    ACTIONS(273), 1,
      anon_sym_SEMI,
    STATE(107), 1,
      sym_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1427] = 4,
    ACTIONS(273), 1,
      anon_sym_SEMI,
    ACTIONS(275), 1,
      anon_sym_COMMA,
    STATE(92), 1,
      aux_sym_promise_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1441] = 4,
    ACTIONS(273), 1,
      anon_sym_SEMI,
    ACTIONS(275), 1,
      anon_sym_COMMA,
    STATE(81), 1,
      aux_sym_promise_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1455] = 4,
    ACTIONS(89), 1,
      sym_identifier,
    ACTIONS(277), 1,
      anon_sym_SEMI,
    STATE(107), 1,
      sym_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1469] = 4,
    ACTIONS(89), 1,
      sym_identifier,
    ACTIONS(279), 1,
      anon_sym_SEMI,
    STATE(107), 1,
      sym_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1483] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(219), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [1493] = 3,
    ACTIONS(281), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(283), 2,
      anon_sym_RBRACE,
      sym_class_guard,
  [1505] = 4,
    ACTIONS(285), 1,
      anon_sym_SEMI,
    ACTIONS(287), 1,
      anon_sym_COMMA,
    STATE(81), 1,
      aux_sym_promise_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1519] = 4,
    ACTIONS(252), 1,
      anon_sym_SEMI,
    ACTIONS(289), 1,
      anon_sym_COMMA,
    STATE(81), 1,
      aux_sym_promise_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1533] = 4,
    ACTIONS(89), 1,
      sym_identifier,
    ACTIONS(285), 1,
      anon_sym_SEMI,
    STATE(107), 1,
      sym_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1547] = 4,
    ACTIONS(291), 1,
      sym_identifier,
    ACTIONS(293), 1,
      anon_sym_RPAREN,
    STATE(103), 1,
      aux_sym_parameter_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1561] = 4,
    ACTIONS(89), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_SEMI,
    STATE(107), 1,
      sym_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1575] = 4,
    ACTIONS(285), 1,
      anon_sym_SEMI,
    ACTIONS(287), 1,
      anon_sym_COMMA,
    STATE(80), 1,
      aux_sym_promise_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1589] = 3,
    ACTIONS(299), 1,
      sym_promise_guard,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(297), 2,
      anon_sym_RBRACE,
      sym_class_guard,
  [1601] = 3,
    ACTIONS(301), 1,
      sym_identifier,
    ACTIONS(303), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1612] = 3,
    ACTIONS(89), 1,
      sym_identifier,
    STATE(107), 1,
      sym_attribute,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1623] = 3,
    ACTIONS(235), 1,
      anon_sym_LBRACE,
    STATE(67), 1,
      sym_body_block_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1634] = 3,
    ACTIONS(305), 1,
      anon_sym_COMMA,
    ACTIONS(307), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1645] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(309), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [1654] = 3,
    ACTIONS(311), 1,
      sym_identifier,
    STATE(109), 1,
      aux_sym_parameter_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1665] = 3,
    ACTIONS(301), 1,
      sym_identifier,
    ACTIONS(313), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1676] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(315), 2,
      anon_sym_RBRACE,
      sym_class_guard,
  [1685] = 3,
    ACTIONS(196), 1,
      anon_sym_LBRACE,
    STATE(53), 1,
      sym_bundle_block_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1696] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
    ACTIONS(264), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [1705] = 3,
    ACTIONS(303), 1,
      anon_sym_RPAREN,
    ACTIONS(317), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1716] = 3,
    ACTIONS(319), 1,
      sym_identifier,
    STATE(109), 1,
      aux_sym_parameter_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1727] = 3,
    ACTIONS(322), 1,
      anon_sym_LBRACE,
    STATE(71), 1,
      sym_promise_block_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1738] = 2,
    ACTIONS(324), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1746] = 2,
    ACTIONS(301), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1754] = 2,
    ACTIONS(326), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1762] = 2,
    ACTIONS(328), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1770] = 2,
    ACTIONS(330), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1778] = 2,
    ACTIONS(332), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1786] = 2,
    ACTIONS(334), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1794] = 2,
    ACTIONS(336), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1802] = 2,
    ACTIONS(338), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1810] = 2,
    ACTIONS(340), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1818] = 2,
    ACTIONS(342), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1826] = 2,
    ACTIONS(344), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1834] = 2,
    ACTIONS(346), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1842] = 2,
    ACTIONS(348), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1850] = 2,
    ACTIONS(350), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1858] = 2,
    ACTIONS(352), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1866] = 2,
    ACTIONS(354), 1,
      sym_qualified_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1874] = 2,
    ACTIONS(356), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1882] = 2,
    ACTIONS(358), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1890] = 2,
    ACTIONS(360), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1898] = 2,
    ACTIONS(362), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1906] = 2,
    ACTIONS(364), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
  [1914] = 2,
    ACTIONS(366), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_macro,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 33,
  [SMALL_STATE(4)] = 68,
  [SMALL_STATE(5)] = 101,
  [SMALL_STATE(6)] = 136,
  [SMALL_STATE(7)] = 165,
  [SMALL_STATE(8)] = 194,
  [SMALL_STATE(9)] = 223,
  [SMALL_STATE(10)] = 249,
  [SMALL_STATE(11)] = 275,
  [SMALL_STATE(12)] = 299,
  [SMALL_STATE(13)] = 325,
  [SMALL_STATE(14)] = 349,
  [SMALL_STATE(15)] = 376,
  [SMALL_STATE(16)] = 403,
  [SMALL_STATE(17)] = 430,
  [SMALL_STATE(18)] = 455,
  [SMALL_STATE(19)] = 480,
  [SMALL_STATE(20)] = 499,
  [SMALL_STATE(21)] = 518,
  [SMALL_STATE(22)] = 541,
  [SMALL_STATE(23)] = 562,
  [SMALL_STATE(24)] = 577,
  [SMALL_STATE(25)] = 596,
  [SMALL_STATE(26)] = 610,
  [SMALL_STATE(27)] = 628,
  [SMALL_STATE(28)] = 642,
  [SMALL_STATE(29)] = 660,
  [SMALL_STATE(30)] = 678,
  [SMALL_STATE(31)] = 690,
  [SMALL_STATE(32)] = 704,
  [SMALL_STATE(33)] = 724,
  [SMALL_STATE(34)] = 738,
  [SMALL_STATE(35)] = 750,
  [SMALL_STATE(36)] = 762,
  [SMALL_STATE(37)] = 776,
  [SMALL_STATE(38)] = 790,
  [SMALL_STATE(39)] = 804,
  [SMALL_STATE(40)] = 822,
  [SMALL_STATE(41)] = 834,
  [SMALL_STATE(42)] = 846,
  [SMALL_STATE(43)] = 858,
  [SMALL_STATE(44)] = 870,
  [SMALL_STATE(45)] = 884,
  [SMALL_STATE(46)] = 896,
  [SMALL_STATE(47)] = 910,
  [SMALL_STATE(48)] = 924,
  [SMALL_STATE(49)] = 938,
  [SMALL_STATE(50)] = 949,
  [SMALL_STATE(51)] = 960,
  [SMALL_STATE(52)] = 975,
  [SMALL_STATE(53)] = 990,
  [SMALL_STATE(54)] = 1001,
  [SMALL_STATE(55)] = 1018,
  [SMALL_STATE(56)] = 1029,
  [SMALL_STATE(57)] = 1040,
  [SMALL_STATE(58)] = 1055,
  [SMALL_STATE(59)] = 1066,
  [SMALL_STATE(60)] = 1077,
  [SMALL_STATE(61)] = 1088,
  [SMALL_STATE(62)] = 1103,
  [SMALL_STATE(63)] = 1114,
  [SMALL_STATE(64)] = 1131,
  [SMALL_STATE(65)] = 1146,
  [SMALL_STATE(66)] = 1161,
  [SMALL_STATE(67)] = 1172,
  [SMALL_STATE(68)] = 1183,
  [SMALL_STATE(69)] = 1198,
  [SMALL_STATE(70)] = 1215,
  [SMALL_STATE(71)] = 1226,
  [SMALL_STATE(72)] = 1237,
  [SMALL_STATE(73)] = 1254,
  [SMALL_STATE(74)] = 1269,
  [SMALL_STATE(75)] = 1286,
  [SMALL_STATE(76)] = 1301,
  [SMALL_STATE(77)] = 1315,
  [SMALL_STATE(78)] = 1329,
  [SMALL_STATE(79)] = 1343,
  [SMALL_STATE(80)] = 1357,
  [SMALL_STATE(81)] = 1371,
  [SMALL_STATE(82)] = 1385,
  [SMALL_STATE(83)] = 1399,
  [SMALL_STATE(84)] = 1413,
  [SMALL_STATE(85)] = 1427,
  [SMALL_STATE(86)] = 1441,
  [SMALL_STATE(87)] = 1455,
  [SMALL_STATE(88)] = 1469,
  [SMALL_STATE(89)] = 1483,
  [SMALL_STATE(90)] = 1493,
  [SMALL_STATE(91)] = 1505,
  [SMALL_STATE(92)] = 1519,
  [SMALL_STATE(93)] = 1533,
  [SMALL_STATE(94)] = 1547,
  [SMALL_STATE(95)] = 1561,
  [SMALL_STATE(96)] = 1575,
  [SMALL_STATE(97)] = 1589,
  [SMALL_STATE(98)] = 1601,
  [SMALL_STATE(99)] = 1612,
  [SMALL_STATE(100)] = 1623,
  [SMALL_STATE(101)] = 1634,
  [SMALL_STATE(102)] = 1645,
  [SMALL_STATE(103)] = 1654,
  [SMALL_STATE(104)] = 1665,
  [SMALL_STATE(105)] = 1676,
  [SMALL_STATE(106)] = 1685,
  [SMALL_STATE(107)] = 1696,
  [SMALL_STATE(108)] = 1705,
  [SMALL_STATE(109)] = 1716,
  [SMALL_STATE(110)] = 1727,
  [SMALL_STATE(111)] = 1738,
  [SMALL_STATE(112)] = 1746,
  [SMALL_STATE(113)] = 1754,
  [SMALL_STATE(114)] = 1762,
  [SMALL_STATE(115)] = 1770,
  [SMALL_STATE(116)] = 1778,
  [SMALL_STATE(117)] = 1786,
  [SMALL_STATE(118)] = 1794,
  [SMALL_STATE(119)] = 1802,
  [SMALL_STATE(120)] = 1810,
  [SMALL_STATE(121)] = 1818,
  [SMALL_STATE(122)] = 1826,
  [SMALL_STATE(123)] = 1834,
  [SMALL_STATE(124)] = 1842,
  [SMALL_STATE(125)] = 1850,
  [SMALL_STATE(126)] = 1858,
  [SMALL_STATE(127)] = 1866,
  [SMALL_STATE(128)] = 1874,
  [SMALL_STATE(129)] = 1882,
  [SMALL_STATE(130)] = 1890,
  [SMALL_STATE(131)] = 1898,
  [SMALL_STATE(132)] = 1906,
  [SMALL_STATE(133)] = 1914,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [15] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__value_list, 2, 0, 0),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [27] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__value_list, 3, 0, 0),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [33] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__promises, 2, 0, 0),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [37] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__promises, 2, 0, 0),
  [39] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__promises_repeat1, 2, 0, 0), SHIFT_REPEAT(120),
  [42] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__promises_repeat1, 2, 0, 0),
  [44] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__promises_repeat1, 2, 0, 0), SHIFT_REPEAT(21),
  [47] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__promises_repeat1, 2, 0, 0),
  [49] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0),
  [51] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(129),
  [54] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(122),
  [57] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(131),
  [60] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__promises, 1, 0, 0),
  [62] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__promises, 1, 0, 0),
  [64] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1, 0, 0),
  [66] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [68] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [70] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [72] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bundle_section, 1, 0, 0),
  [74] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bundle_section, 1, 0, 0),
  [76] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [78] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [80] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [82] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_body_block_body_repeat1, 2, 0, 0), SHIFT_REPEAT(120),
  [85] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_body_block_body_repeat1, 2, 0, 0),
  [87] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_guarded_body_attributes, 2, 0, 0),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [97] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_guarded_promises, 1, 0, 0),
  [99] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_guarded_promises, 1, 0, 0),
  [101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__right_value, 1, 0, 0),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_guarded_body_attributes, 1, 0, 0),
  [107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_promise, 3, 0, 6),
  [109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_promise, 3, 0, 6),
  [111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bundle_section, 2, 0, 0),
  [113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bundle_section, 2, 0, 0),
  [115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_promise, 2, 0, 6),
  [117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_promise, 2, 0, 6),
  [119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bundle_section, 3, 0, 0),
  [121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bundle_section, 3, 0, 0),
  [123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_bundle_section_repeat1, 2, 0, 0),
  [125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_bundle_section_repeat1, 2, 0, 0),
  [127] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bundle_section_repeat1, 2, 0, 0), SHIFT_REPEAT(22),
  [130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 2, 0, 0),
  [132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_promise, 7, 0, 8),
  [134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_promise, 7, 0, 8),
  [136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_half_promise, 2, 0, 0),
  [142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_half_promise, 2, 0, 0),
  [144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 3, 0, 0),
  [146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 3, 0, 7),
  [148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_promise, 4, 0, 8),
  [150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_promise, 4, 0, 8),
  [152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_promise, 4, 0, 6),
  [154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_promise, 4, 0, 6),
  [156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_half_promise, 3, 0, 0),
  [158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_half_promise, 3, 0, 0),
  [160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dollar_expression, 4, 0, 9),
  [162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dollar_expression, 4, 0, 10),
  [164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_at_expression, 4, 0, 11),
  [166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 4, 0, 7),
  [168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_promise, 5, 0, 8),
  [170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_promise, 5, 0, 8),
  [172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_promise, 5, 0, 6),
  [174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_promise, 5, 0, 6),
  [176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_half_promise, 4, 0, 0),
  [178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_half_promise, 4, 0, 0),
  [180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_promise, 6, 0, 8),
  [182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_promise, 6, 0, 8),
  [184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_promise_block_body, 4, 0, 0),
  [186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_promise_block_body, 2, 0, 0),
  [188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bundle_block, 5, 0, 3),
  [196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bundle_block, 4, 0, 3),
  [202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_body_block_body, 2, 0, 0),
  [204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bundle_block_body, 2, 0, 0),
  [208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_body_block_body, 3, 0, 0),
  [210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bundle_block_body, 3, 0, 0),
  [212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_bundle_block_body_repeat1, 2, 0, 0),
  [214] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bundle_block_body_repeat1, 2, 0, 0), SHIFT_REPEAT(16),
  [217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_body_block, 4, 0, 1),
  [219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__value_list_repeat1, 2, 0, 0),
  [221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__value_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8),
  [224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_body_block_body, 4, 0, 0),
  [228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_body_block, 5, 0, 1),
  [230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_body_block_body_repeat2, 2, 0, 0),
  [232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_body_block_body_repeat2, 2, 0, 0), SHIFT_REPEAT(24),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_promise_block_body, 3, 0, 0),
  [239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_promise_block, 4, 0, 2),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_promise_block_body_repeat1, 2, 0, 0),
  [245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_promise_block_body_repeat1, 2, 0, 0), SHIFT_REPEAT(24),
  [248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__value_list, 1, 0, 0),
  [250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_promise_repeat1, 2, 0, 0),
  [266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_promise_repeat1, 2, 0, 0), SHIFT_REPEAT(99),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__body_attribute, 2, 0, 0),
  [283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__body_attribute, 2, 0, 0),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_guarded_promises, 2, 0, 0),
  [299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_guarded_promises, 2, 0, 0),
  [301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, 0, 5),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_promise_block_body_repeat1, 1, 0, 4),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(111),
  [322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [342] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 5, 0, 0),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_cfengine(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
